<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';

  withDefaults(
    defineProps<{
      data: Product[];
      total: number;
      pageSize: number;
      currentPage: number;
      isLoading?: boolean;
    }>(),
    {
      isLoading: false,
    },
  );

  const emit = defineEmits(['changeCurrentPage']);

  const handleChangeCurrentPage = (page: number) => {
    emit('changeCurrentPage', page);
  };
</script>

<template>
  <div
    v-if="isLoading"
    class="grid grid-cols-[repeat(auto-fill,_minmax(200px,_1fr))] justify-items-center gap-6 xl:gap-8"
  >
    <SwProductCard v-for="size in 6" :key="size" class="w-full" :loading="true" />
  </div>
  <div v-else-if="!data?.length" class="h-30 flex items-center justify-center">
    <h6 class="font-bold">{{ $t('product.messages.noProductsFound') }}</h6>
  </div>
  <div v-else name="pagination-product-list">
    <div
      class="grid grid-cols-[repeat(auto-fill,_minmax(200px,_1fr))] justify-items-center gap-6 xl:gap-8"
    >
      <template v-for="item in data" :key="item.id">
        <slot v-bind="item" />
      </template>
    </div>

    <slot name="pagination">
      <SwPagination
        v-if="total"
        :total="total"
        class="mt-6 justify-center"
        :current-page="currentPage"
        :page-size="pageSize"
        @update:model-value="handleChangeCurrentPage"
      />
    </slot>
  </div>
</template>
